REM Hilfsprogrammm (V 0.1) zur Berechnung von Punkten und Linien fr
REM 3D-Object v 0.5 der LesInk Productions
REM
REM Erstellt mit Microsoft QBASIC-Interpreter
REM
REM Autor:
REM Dr. Andr Cajar * Ludwig-Sievers-Ring 29 * D 30659 Hannover
REM Tel: (0511) 64 98 042
REM
REM Dieses Programm soll Anregung zur weiteren Beschftigung mit "3D-Object"
REM sein. Wer setzt es mit dem SDK nach Geos20 um ???
REM Die Nutzung dieses Programms ist frei.
REM Der Autor (er ist kein Programmierer) bittet aber bei Hinweisen, nde-
REM rungen, Ergnzungen, Wnschen ..., der Umsetzung nach Geos20 um Mitteilung.
REM ber eine Zusendung der neuen Programmversion freut er sich besonders.
REM
REM Windows-Funktion aus: "Fenster unter QBASIC"
REM in DOS International 9/94 S. 234/235
REM
REM wi=windows (Fenster)
REM it=invtdline (invertierte Linie)
REM pa = panel (Leiste)
REM tx=textbox (Texttasten)
REM td=tdbox (Box)

DECLARE SUB wi (x1!, y1!, x2!, y2!, col!)
DECLARE SUB it (x1!, y1!, x2!, y2!)
DECLARE SUB pa (x1!, y1!, x2!, y2!)
DECLARE SUB tx (x1!, y1!, x2!, y2!, text$)
DECLARE SUB td (x1!, y1!, x2!, y2!)

SCREEN 12: COLOR 15

wi 0, 0, 640, 480, 3
tx 45, 32, 590, 235, "Hilfsprogrammm (V 0.1) zur Berechnung von Punkten und Linien fr"

LOCATE 6, 20: PRINT "3D-Object v 0.5 der LesInk Productions"
LOCATE 7, 15: PRINT "Es erstellt eine Datei 3DOBJ.TXT mit allen Angaben."
LOCATE 9, 8: PRINT "Achtung: Pfadangabe in der OPEN-Anweisung mu entsprechend Ihrer"
LOCATE 10, 22: PRINT "PC-Konfiguration angepat werden !!!"
LOCATE 12, 23: PRINT "z.B. C:\GEOS20\DOCUMENT\3DOBJ.TXT"
LOCATE 14, 8: PRINT "Abbruch mit Strg+C; weiter mit beliebiger Taste"
DO: LOOP UNTIL INKEY$ <> ""

OPEN "C:\temp\3DOBJ.TXT" FOR OUTPUT AS #1
   p = 0: L = 0: m = 10: PI = 3.141592654#

10 wi 20, 25, 620, 340, 0
LOCATE 5, 5: PRINT "folgende 3-D-Objekte knnen fr '3D-Object' vorbereitet werden:"
LOCATE 7, 5: PRINT "Quader    ....  : 1      Text         ....   : noch nicht implementiert"
LOCATE 8, 5: PRINT "Prisma    ....  : 2"
LOCATE 9, 5: PRINT "Pyramide  ....  : 3"
LOCATE 10, 5: PRINT "Kugel     ....  : 4      Kugelsegment ....   : noch nicht implementiert"
LOCATE 11, 5: PRINT "Zylinder, Kegel          Zylindersegment     : noch nicht implementiert"
LOCATE 12, 5: PRINT "oder Kegelstumpf: 5      Torus        ....   : noch nicht implementiert"
LOCATE 13, 5: PRINT "                         flatterndes Banner  : noch nicht implementiert"
LOCATE 14, 5: PRINT "                         Rotation einer Kurve: noch nicht implementiert"
LOCATE 20, 5: INPUT "Auswahl :"; E

wi 20, 25, 620, 340, 0
LOCATE 5, 5: PRINT "Hinweis: - Lngen 1 ... 40 Einheiten (bei Radien 0.5 ...20 Einheiten)"
LOCATE 6, 5: PRINT "         - nur eine Stelle nach dem Dezimalpunkt (z.B Breite= 10.5)"

IF E = 1 THEN
        LOCATE 8, 5: PRINT "Quader"
        PRINT #1, "; Quader"
        LOCATE 10, 5: INPUT "Eckpunkt in X :"; x1: x1 = x1 * m
        LOCATE 11, 5: INPUT "Eckpunkt in Y :"; y1: y1 = y1 * m
        LOCATE 12, 5: INPUT "Eckpunkt in Z :"; z1: z1 = z1 * m
        LOCATE 14, 5: INPUT "Breite in X   :"; x2: x2 = x2 * m
        LOCATE 15, 5: INPUT "Lnge  in Y   :"; y2: y2 = y2 * m
        LOCATE 16, 5: INPUT "Hhe   in Z   :"; z2: z2 = z2 * m

        PRINT #1, ";Punkte Grund- und Deckflche"

        PRINT #1, "point"; p; x1; y1; z1: p = p + 1
        PRINT #1, "point"; p; x1 + x2; y1; z1: p = p + 1
        PRINT #1, "point"; p; x1 + x2; y1 + y2; z1: p = p + 1
        PRINT #1, "point"; p; x1; y1 + y2; z1: p = p + 1

        PRINT #1, "point"; p; x1; y1; z1 + z2: p = p + 1
        PRINT #1, "point"; p; x1 + x2; y1; z1 + z2: p = p + 1
        PRINT #1, "point"; p; x1 + x2; y1 + y2; z1 + z2: p = p + 1
        PRINT #1, "point"; p; x1; y1 + y2; z1 + z2: p = p + 1
        PRINT #1,
       
        PRINT #1, ";Linien Grund- und Deckflche"

        PRINT #1, "line"; L; p - 8; p - 7: L = L + 1
        PRINT #1, "line"; L; p - 7; p - 6: L = L + 1
        PRINT #1, "line"; L; p - 6; p - 5: L = L + 1
        PRINT #1, "line"; L; p - 5; p - 8: L = L + 1
       
        PRINT #1, "line"; L; p - 4; p - 3: L = L + 1
        PRINT #1, "line"; L; p - 3; p - 2: L = L + 1
        PRINT #1, "line"; L; p - 2; p - 1: L = L + 1
        PRINT #1, "line"; L; p - 1; p - 4: L = L + 1
        PRINT #1,

        PRINT #1, ";Linien Seitenfchen"
       
        PRINT #1, "line"; L; p - 8; p - 4: L = L + 1
        PRINT #1, "line"; L; p - 7; p - 3: L = L + 1
        PRINT #1, "line"; L; p - 6; p - 2: L = L + 1
        PRINT #1, "line"; L; p - 5; p - 1: L = L + 1
        PRINT #1,
END IF

IF E = 2 THEN
        LOCATE 8, 10: PRINT "Prisma"
        PRINT #1, "; Prisma"
        LOCATE 10, 10: INPUT "Anzahl der Eckpunkte (Grundflche) "; n
        LOCATE 11, 10: INPUT "Hhe des Prismas "; h: h = h * m
        FOR i = 1 TO n
                CLS
                LOCATE 8, 10: PRINT "Prisma"
                LOCATE 13, 10: PRINT i; ". Eckpunkt der Grundflche:"
                LOCATE 15, 10: INPUT "Eckpunkt in X :"; X: X = X * m
                LOCATE 16, 10: INPUT "Eckpunkt in Y :"; Y: Y = Y * m
                LOCATE 17, 10: INPUT "Eckpunkt in Z :"; Z: Z = Z * m
                PRINT #1, "point"; p; X; Y; Z: p = p + 1
                PRINT #1, "point"; p; X; Y; Z + h: p = p + 1
        NEXT i
        PRINT #1,
       
        PRINT #1, ";Linien Grundflche"

        FOR i = n * 2 TO 2 STEP -2
          IF p - i + 2 < p THEN
                PRINT #1, "line"; L; p - i; p - i + 2: L = L + 1
          ELSE
                PRINT #1, "line"; L; p - i; p - n * 2: L = L + 1
          END IF
        NEXT i
        PRINT #1,
       
        PRINT #1, ";Linien Deckflche"
       
        FOR i = n * 2 - 1 TO 1 STEP -2
          IF p - i + 2 < p THEN
                PRINT #1, "line"; L; p - i; p - i + 2: L = L + 1
        ELSE
                PRINT #1, "line"; L; p - i; p - n * 2 + 1: L = L + 1
          END IF
        NEXT i
        PRINT #1,

        PRINT #1, ";Linien Seitenflchen"
      
        FOR i = n * 2 TO 2 STEP -2
          PRINT #1, "line"; L; p - i; p - i + 1: L = L + 1
        NEXT i
        PRINT #1,
       
        PRINT #1,
END IF

IF E = 3 THEN
        LOCATE 8, 10: PRINT "Pyramide"
        PRINT #1, "; Pyramide"
        LOCATE 10, 5: INPUT "Anzahl der Eckpunkte (Grundflche) "; n
        PRINT
        FOR i = 1 TO n
                CLS
                LOCATE 8, 10: PRINT "Pyramide"
                LOCATE 10, 10: PRINT i; ". Eckpunkt:"
                LOCATE 11, 10: INPUT "Eckpunkt in X :"; X: X = X * m
                LOCATE 12, 10: INPUT "Eckpunkt in Y :"; Y: Y = Y * m
                LOCATE 13, 10: INPUT "Eckpunkt in Z :"; Z: Z = Z * m
                PRINT #1, "point"; p; X; Y; Z: p = p + 1
        NEXT i
        LOCATE 15, 10: PRINT "Spitze der Pyramide:"
        LOCATE 16, 10: INPUT "Eckpunkt in X :"; X: X = X * m
        LOCATE 17, 10: INPUT "Eckpunkt in Y :"; Y: Y = Y * m
        LOCATE 18, 10: INPUT "Eckpunkt in Z :"; Z: Z = Z * m
        PRINT #1, "point"; p; X; Y; Z: p = p + 1
        PRINT #1,
    
        PRINT #1, ";Linien Grundflche"

        FOR i = n + 1 TO 2 STEP -1
          IF p - i + 2 < p THEN
                PRINT #1, "line"; L; p - i; p - i + 1: L = L + 1
          ELSE
                PRINT #1, "line"; L; p - i; p - n - 1: L = L + 1
          END IF
        NEXT i
        PRINT #1,
       
        PRINT #1, ";Linien Seitenflchen"
       
        FOR i = n + 1 TO 2 STEP -1
                PRINT #1, "line"; L; p - i; p - 1: L = L + 1
        NEXT i
        PRINT #1,
END IF

IF E = 4 THEN
        LOCATE 8, 10: PRINT "Kugel"
        PRINT #1, "; Kugel"
        LOCATE 10, 10: INPUT "Mittelpunkt in X :"; XM: XM = XM * m
        LOCATE 11, 10: INPUT "Mittelpunkt in Y :"; YM: YM = YM * m
        LOCATE 12, 10: INPUT "Mittelpunkt in Z :"; ZM: ZM = ZM * m
        LOCATE 14, 10: INPUT "Radius der Kugel :"; r: r = r * m

n = 6 ' n bestimmt Anzahl der Linien der Kugel
      ' nachfolgende Berechnung nur fr n=6 korrekt
k = p ' k=Merker fr Anfangswert von p
 
        PRINT #1, ";Sdpol"

        PRINT #1, "point"; p;
       
        PRINT #1, USING "#####"; XM; YM; ZM - r: p = p + 1
        PRINT #1,

        PRINT #1, ";Punkte untere Halbkugel"

        FOR i = n / 2 - 1 TO 1 STEP -1
          PRINT #1,
            FOR j = 0 TO 2 * n - 1
                PRINT #1, "point"; p;
                PRINT #1, USING "#####"; XM + r * COS(j / n * PI) * COS(i / n * PI) + .5;
                PRINT #1, USING "#####"; YM + r * SIN(j / n * PI) * COS(i / n * PI) + .5;
                PRINT #1, USING "#####"; ZM - r * SIN(i / n * PI) + .5: p = p + 1
            NEXT j
            PRINT #1,
        NEXT i
       
        PRINT #1, ";Punkte quator"

        FOR j = 0 TO 2 * n - 1
                PRINT #1, "point"; p;
                PRINT #1, USING "#####"; XM + r * COS(j / n * PI) + .5;
                PRINT #1, USING "#####"; YM + r * SIN(j / n * PI) + .5; ZM: p = p + 1
        NEXT j
        PRINT #1,
       
        PRINT #1, ";Punkte obere Halbkugel"
  
        FOR i = 1 TO n / 2 - 1
          PRINT #1,
          FOR j = 0 TO 2 * n - 1
                PRINT #1, "point"; p;
                PRINT #1, USING "#####"; XM + r * COS(j / n * PI) * COS(i / n * PI) + .5;
                PRINT #1, USING "#####"; YM + r * SIN(j / n * PI) * COS(i / n * PI) + .5;
                PRINT #1, USING "#####"; ZM + r * SIN(i / n * PI) + .5: p = p + 1
          NEXT j
        NEXT i
        PRINT #1,
       
        PRINT #1, ";Nordpol"

        PRINT #1, "point"; p; XM; YM; ZM + r: p = p + 1
        PRINT #1,
      
        PRINT #1, ";sdliche Polstrahlen"

        FOR i = 1 TO 2 * n
                PRINT #1, "line"; L; k; i + k: L = L + 1
        NEXT i
        PRINT #1,
 
        PRINT #1, ";senkrechte Seitenlinien"

        FOR i = 1 TO 2 * n
           FOR j = 0 TO (p - k) / 2 + 2 * n STEP 2 * n
                PRINT #1, "line"; L; i + j + k; i + j + 2 * n + k: L = L + 1
           NEXT j
           PRINT #1,
        NEXT i
       
        PRINT #1, ";nrdliche Polstrahlen"

        FOR i = p - 2 * n - 1 TO p - 2
                PRINT #1, "line"; L; i; p - 1: L = L + 1
        NEXT i
        PRINT #1,
       
        PRINT #1, ";quatoriallinien"
        FOR j = 0 TO p - 2 * n - k STEP 2 * n
           FOR i = k + 1 TO k + 2 * n - 1
                PRINT #1, "line"; L; j + i; j + i + 1: L = L + 1
           NEXT i
           PRINT #1, "line"; L; j + k + 2 * n; j + k + 1: L = L + 1
        PRINT #1,
        NEXT j

END IF

IF E = 5 THEN
        LOCATE 8, 10: PRINT "Zylinder, Kegel oder Kegelstumpf"
        LOCATE 9, 10: PRINT "Kegel --> Zylinder mit oberem oder unterem Radius=0"
        PRINT #1, "; Zylinder, Kegel oder Kegelstumpf"
        PRINT
        LOCATE 11, 10: INPUT "Mittelpunkt in X     :"; XM: XM = XM * m
        LOCATE 12, 10: INPUT "Mittelpunkt in Y     :"; YM: YM = YM * m
        LOCATE 13, 10: INPUT "Mittelpunkt in Z     :"; ZM: ZM = ZM * m
        LOCATE 15, 10: INPUT "unterer Radius des Zylinders :"; r1: r1 = r1 * m
        LOCATE 16, 10: INPUT "oberer Radius des Zylinders  :"; r2: r2 = r2 * m
        LOCATE 17, 10: INPUT "Hhe des Zylinders           :"; h: h = h * m
        LOCATE 19, 10: INPUT "Anzahl der Linien (4...30)   :"; t: n = t / 2

REM t bestimmt Anzahl der Linien im Zylinder, t=4 --> Pyramidenstumpf

   PRINT #1, ";Punkte auf Grundflche"

   FOR j = 0 TO 2 * n - 1
        PRINT #1, "point"; p;
        PRINT #1, USING "#####"; XM + r1 * COS(j / n * PI) + .5;
        PRINT #1, USING "#####"; YM + r1 * SIN(j / n * PI) + .5; ZM: p = p + 1
   NEXT j
   PRINT #1,
  
   PRINT #1, ";Punkte auf Deckflche"
  
   FOR j = 0 TO 2 * n - 1
        PRINT #1, "point"; p;
        PRINT #1, USING "#####"; XM + r2 * COS(j / n * PI) + .5;
        PRINT #1, USING "#####"; YM + r2 * SIN(j / n * PI) + .5; ZM + h: p = p + 1
   NEXT j
   PRINT #1,

   PRINT #1, ";radiale Linien Grundflche"

   FOR i = p - 4 * n TO p - 3 * n - 1
        PRINT #1, "line"; L; i; i + n: L = L + 1
   NEXT i
   PRINT #1,

   PRINT #1, ";radiale Linien Deckflche"

   FOR i = p - 2 * n TO p - 1 * n - 1
        PRINT #1, "line"; L; i; i + n: L = L + 1
   NEXT i
   PRINT #1,

   PRINT #1, ";senkrechter Linien"

   FOR i = p - 4 * n TO p - 2 * n - 1
        PRINT #1, "line"; L; i; i + 2 * n: L = L + 1
   NEXT i
   PRINT #1,

   PRINT #1, ";Umfangslinien Grundflche"

   FOR i = p - 4 * n TO p - 2 * n - 2
        PRINT #1, "line"; L; i; i + 1: L = L + 1
   NEXT i
   PRINT #1, "line"; L; p - 2 * n - 1; p - 4 * n: L = L + 1
   PRINT #1,

   PRINT #1, ";Umfangslinien Deckflche"

   FOR i = p - 2 * n TO p - 2
        PRINT #1, "line"; L; i; i + 1: L = L + 1
   NEXT i
   PRINT #1, "line"; L; p - 1; p - 2 * n: L = L + 1
   PRINT #1,
END IF

LOCATE 20, 5: INPUT "Weitere Krper ? J/N"; E$: IF E$ = "j" OR E$ = "J" THEN 10
BEEP
CLS
wi 50, 310, 580, 440, 0

LOCATE 23, 25: PRINT "Datei 3DOBJ.TXT wurde erstellt"
LOCATE 25, 16: PRINT "Aufruf mit load von Geoworks-3D-Object aus mglich"
LOCATE 27, 8: PRINT "[ENTER]"
DO: LOOP UNTIL INKEY$ <> ""
CLOSE
END

SUB gr (x1, y1, x2, y2)
        VIEW
        it x1, y1, x2, y2
        td x1 + 1, y1 + 1, x2 - 1, y2 - 1
END SUB

SUB invtdbox (x1, y1, x2, y2)
        VIEW
        LINE (x1 + 1, y1 + 1)-(x2 - 1, y2 - 1), 7, BF
        it x1, y1, x2, y2
END SUB

SUB it (x1, y1, x2, y2)
        VIEW
        LINE (x1, y2)-(x1, y1), 8
        LINE (x1, y1)-(x2, y1), 8
        LINE (x1, y2)-(x2, y2), 15
        LINE (x2, y2)-(x2, y1), 15
END SUB

SUB pa (x1, y1, x2, y2)
        VIEW
        LINE (x1 + 3, y1 + 3)-(x2 + 3, y2 + 3), 8, BF
        LINE (x1, y1)-(x2, y2), 7, BF
        LINE (x1, y1)-(x2, y2), 0, B
        td x1 + 1, y1 + 1, x2 - 1, y2 - 1
        it x1 + 5, y1 + 5, x2 - 5, y2 - 5
        VIEW (x1 + 7, y1 + 7)-(x2 - 7, y2 - 7)
END SUB

SUB tb (x1, y1, x2, y2)
        VIEW
        LINE (x1 + 1, y1 + 1)-(x2 - 1, y2 - 1), 7, BF
        td x1, y1, x2, y2
END SUB

SUB td (x1, y1, x2, y2)
        VIEW
        LINE (x1, y2)-(x1, y1), 15
        LINE (x1, y1)-(x2, y1), 15
        LINE (x1, y2)-(x2, y2), 8
        LINE (x2, y2)-(x2, y1), 8
END SUB

SUB tx (x1, y1, x2, y2, text$)
        x1 = INT(x1 / 8) * 8: y1 = INT(y1 / 16) * 16
        x2 = INT(x2 / 8) * 8: y2 = INT(y2 / 16) * 16
        wi x1 + 4, y1 + 4, x2 + 4, y2 + 4, 0
        xz% = x1 / 8 + 3: yz% = y1 / 16 + 3
        COLOR 15
        LOCATE yz%, xz%
        PRINT text$
END SUB

SUB wi (x1, y1, x2, y2, col!)
        IF x2 < 100 THEN x2 = 100
        IF y2 < 32 THEN y2 = 32
        pa x1, y1, x2, y2
        VIEW
        td x1 + 7, y1 + 7, x1 + 23, y1 + 23
        td x1 + 24, y1 + 7, x2 - 41, y1 + 23
        td x2 - 40, y1 + 7, x2 - 24, y1 + 23
        td x2 - 23, y1 + 7, x2 - 7, y1 + 23
        LINE (x1 + 7, y1 + 24)-(x2 - 7, y1 + 24), 0
        LINE (x1 + 6, y1 + 6)-(x2 - 6, y1 + 23), 8, B
        VIEW (x1 + 7, y1 + 25)-(x2 - 7, y2 - 7), col!, 0
END SUB

